/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy.ui;

import it.tidalwave.bluebill.mobile.preferences.TaxonomyPreferences;
import it.tidalwave.netbeans.util.Locator;
import java.util.Locale;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @stereotype Controller
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class TaxonomyFooterController
  {
    private final TaxonomyPreferences taxonomyPreferences = Locator.find(TaxonomyPreferences.class);

    @Nonnull
    public String getTaxonomyDisplayName()
      {
        return taxonomyPreferences.getTaxonomy().getDisplayName();
      }

    @Nonnull
    public String getTaxonLanguages()
      {
        final StringBuilder buffer = new StringBuilder();
        String separator = "";

        for (final Locale locale : taxonomyPreferences.getTaxonomyLocales())
          {
            buffer.append(separator).append(locale.toString());
            separator = ", ";
          }

        return buffer.toString();
      }
  }
